﻿namespace AMPTests
{
    using System;
    using NUnit.Framework;
    using NUnit.Framework.Constraints;
#if NUNIT_24
    using NUnit.Framework.SyntaxHelpers;
#endif
    using System.Text;

    using AMP;

    [TestFixture]
    public class DelegateBoxTests
    {
        DelegateBox box;
        [SetUp]
        public void Init()
        {
            box = new DelegateBox();
        }

        [Test]
        public void test_set_then_callback()
        {
            Object callbackArg = null;
            box.setCallback(new DelegateBoxCallback(delegate(Object obj) { callbackArg = obj; }));

            Assert.That(callbackArg, Is.Null);

            box.callback((Object)"hello");

            Assert.That("hello", Is.EqualTo((string)callbackArg));
            
        }

        [Test]
        public void test_callback_then_set()
        {
            Object callbackArg = null;
            box.callback((Object)"hello");

            Assert.That(callbackArg, Is.Null);

            box.setCallback(new DelegateBoxCallback(delegate(Object obj) { callbackArg = obj; }));

            Assert.That("hello", Is.EqualTo((string)callbackArg));
        }

    }
}