﻿using System;
using System.Net.Sockets;
using System.Threading;
using Simple_Server;
using AMP;

namespace Simple_Example
{
    class Client
    {
        private static AMP_Protocol protocol;
        static void Main(string[] args)
        {
            string hostname = "localhost";
            int port = 1234;
            var socket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
            socket.Connect(hostname, port);

            // create a transport that reads data from the peer and passes it
            // to the protocol, and allows the protocol to write data to the peer
            var transport = new AMPSocketTransport(socket);
            protocol = new AMP_Protocol(transport);
            transport.Start(); // start the data-reading loop


            while (true)
            {
                // asynchronously call the Sum command on the server
                protocol.BeginCallRemote(new Sum(), new AMP_Msg { { "a", 13 }, { "b", 81 } }, _cb_gotResponse, null);
                Thread.Sleep(1000);
            }
        }
        static void _cb_gotResponse(IAsyncResult ar)
        {
            // will raise if any error occured during the remote call
            AMP_Msg respMsg = protocol.EndCallRemote(ar);
            Console.WriteLine("Got sum: {0}", respMsg["total"]);
        }
    }
}
